﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Services;
using System.IO;
using C1.Web.Wijmo.Controls.C1TreeView;
using System.Net;
using System.Threading;
public partial class _Default : System.Web.UI.Page, ICallbackEventHandler
{
    static int rootcount = 1;
    static int childcount = 1;
    //--------------------------------------------------------------------------------------------------------------
    public void InitializeTree(string parentFolder, C1TreeViewNode parentNode)
    {

        foreach (string folderName in Directory.GetDirectories(Path.Combine(parentFolder, "")))
        {
            DirectoryInfo dir = new DirectoryInfo(folderName);

            C1TreeViewNode node = new C1TreeViewNode();
            node.Text = dir.Name;
            node.CollapsedIconClass = "ui-icon-folder-collapsed";
            node.ExpandedIconClass = "ui-icon-folder-expanded";
            node.ItemIconClass = "ui-icon-document";
            if (parentNode == null)
                C1TreeView1.Nodes.Add(node);
            else
                parentNode.Nodes.Add(node);

            if (dir.GetFiles().Length > 0)
            {
                foreach (FileInfo file in dir.GetFiles())
                {
                    C1TreeViewNode filenode = new C1TreeViewNode();
                    filenode.Text = file.Name;

                    //filenode.CollapsedIconClass = "ui-icon-folder-collapsed";
                    //file.filenode.ExpandedIconClass = "ui-icon-folder-expanded";
                    filenode.ItemIconClass = "ui-icon-file";
                    node.Nodes.Add(filenode);
                }
            }
            if (dir.GetDirectories().Length > 0)
                InitializeTree(dir.FullName, node);

        }

    }
    //---------------------------------------------------------------------------------------------------------
    protected void Page_Load(object sender, EventArgs e)
    {
        string targetFolder = Server.MapPath("~/TargetFolder");
        InitializeTree(targetFolder, null);
        if (!Page.IsPostBack)
        {
            string cbReference = Page.ClientScript.GetCallbackEventReference(this, "arg", "ReceiveServerData", "context");
            if (cbReference != null)
            {
                string callbackScript = string.Format("function CallTheServer(arg, context) {{{0}; }}", cbReference);
                Page.ClientScript.RegisterClientScriptBlock(GetType(), "CallTheServer", callbackScript, true);
            }
        }
    }



    //--------------------------------------------------------------------------------------------------------------
    //CREATE NEW FOLDER
    [WebMethod]
    public static string CreateRoot(string folderName)
    {
        string path = Path.Combine(HttpContext.Current.Server.MapPath("~/TargetFolder"), folderName);
        if (Directory.Exists(path))
        {
            path += rootcount;
            rootcount++;
        }
        DirectoryInfo root = Directory.CreateDirectory(path);

        return root.Name;

    }

    //--------------------------------------------------------------------------------------------------------------
    //CREATE SUBFOLDER
    [WebMethod]
    public static string CreateSubFolder(string path)
    {
        path = Path.Combine(HttpContext.Current.Server.MapPath("~/TargetFolder"), path);

        if (Directory.Exists(path))
        {
            path += childcount;
            childcount++;
        }

        Directory.CreateDirectory(path);
        DirectoryInfo child = new DirectoryInfo(path);
        return child.Name;

    }

    //--------------------------------------------------------------------------------------------------------------
    //DELETE NODE
    [WebMethod]
    public static string DeleteNode(string path)
    {
        path = Path.Combine(HttpContext.Current.Server.MapPath("~/TargetFolder"), path);
        if (Directory.Exists(path))
        {
            DeleteDirectory(path);
        }
        else if (File.Exists(path)){
            File.Delete(path);
        }
        return "deleted";
    }
    public static void DeleteDirectory(string target_dir)
    {
        string[] files = Directory.GetFiles(target_dir);
        string[] dirs = Directory.GetDirectories(target_dir);

        foreach (string file in files)
        {
            File.SetAttributes(file, FileAttributes.Normal);
            File.Delete(file);
        }

        foreach (string dir in dirs)
        {
            DeleteDirectory(dir);
        }

        Directory.Delete(target_dir, false);
    }
    //--------------------------------------------------------------------------------------------------------------
    //RENAME NODE
    [WebMethod]
    public static string RenameNode(string path, string newName)
    {
        path = Path.Combine(HttpContext.Current.Server.MapPath("~/TargetFolder"), path);
        if (Directory.Exists(path))
        {
            DirectoryInfo dir = new DirectoryInfo(path);
            dir.MoveTo(Path.Combine(dir.Parent.FullName, newName));
        }
        else if (File.Exists(path)) {
            FileInfo file = new FileInfo(path);
            file.MoveTo(Path.Combine(file.DirectoryName, newName));
        }
        return "renamed";
    }
    //-------------------------------------------------------------------------------------------------------------
    // UPLOADING A FILE
    //Register callback script, save path retuned from client side in Session variable.
    //Upload a file at Specified path by changing TargetFolder path in ValidatingFile event of C1Upload.

    //3. 
    public void RaiseCallbackEvent(string eventArgument)
    {
        //At this point you will get value "test" (which was set in javascript) in eventArgument
        //You can write your logic here to play with the value of eventArgument
        Session["path"] = eventArgument;  //after this method GetCallbackResult() is called
    }
    //4. 
    public string GetCallbackResult()
    {

        return ""; //value returened to client  side method ReceiveServerData
    }
    //6.
    static int uploadedFileCount = 0;
    protected void C1Upload1_ValidatingFile(object sender, C1.Web.Wijmo.Controls.C1Upload.ValidateFileEventArgs e)
    {
        string path = Path.Combine(Server.MapPath("~/TargetFolder"), HttpContext.Current.Session["path"].ToString());
        while (File.Exists(path))
        {
            path += uploadedFileCount;
            uploadedFileCount++;
        }
        e.UploadedFile.SaveAs(path);
        e.IsValid = false;

       
    }


    //--------------------------------------------------------------------------------------------------
}